Loading...
Searching...
No Matches
Sip_warning

## Macros

#define | sip_warning(sip)
| Access a SIP Warning header structure sip_warning_t from sip_t.
#define | SIP_WARNING_INIT()
| Initializer for structure sip_warning_t.
#define | SIPTAG_WARNING(x)
| Tag list item for pointer to a Warning header structure sip_warning_t.
#define | SIPTAG_WARNING_REF(x)
| Tag list item for reference to a Warning header pointer.
#define | SIPTAG_WARNING_STR(s)
| Tag list item for string with Warning header value.
#define | SIPTAG_WARNING_STR_REF(x)
| Tag list item for reference to a Warning header string.

## Typedefs

typedef msg_warning_t | sip_warning_t
| @

## Functions

issize_t | sip_warning_d (su_home_t *, msg_header_t *, char *s, isize_t slen)
| Parse a SIP Warning header.
issize_t | sip_warning_e (char b[], isize_t bsiz, msg_header_t const *h, int flags)
| Print a SIP Warning header.
sip_warning_t * | sip_warning_init (sip_warning_t x[1])
| Initialize a structure sip_warning_t.
int | sip_is_warning (sip_header_t const *header)
| Test if header object is instance of sip_warning_t.
sip_warning_t * | sip_warning_dup (su_home_t *home, sip_warning_t const *hdr))
| Duplicate a list of Warning header header structures sip_warning_t.
sip_warning_t * | sip_warning_copy (su_home_t *home, sip_warning_t const *hdr))
| Copy a list of Warning header header structures sip_warning_t.
sip_warning_t * | sip_warning_make (su_home_t *home, char const *s))
| Make a Warning header structure sip_warning_t.
sip_warning_t * | sip_warning_format (su_home_t *home, char const *fmt,...)))
| Make a Warning header from formatting result.

## Variables

msg_hclass_t | sip_warning_class []
| Header class for Warning header.
tag_typedef_t | siptag_warning
| Tag for Warning header object.
tag_typedef_t | siptag_warning_str
| Tag for string with Warning header value.

## Detailed Description

## Macro Definition Documentation

## SIP_WARNING_INIT

#define SIP_WARNING_INIT | ( |  | ) |

Initializer for structure sip_warning_t.

A static sip_warning_t structure for Warning header must be initialized with the SIP_WARNING_INIT() macro. For instance,

sip_warning_t sip_warning = SIP_WARNING_INIT;
SIP_WARNING_INIT
#define SIP_WARNING_INIT()
Initializer for structure sip_warning_t.
Definition sip_protos.h:11096
sip_warning_t
msg_warning_t sip_warning_t
@
Definition sip.h:201
sip_warning
#define sip_warning(sip)
Access a SIP Warning header structure sip_warning_t from sip_t.
Definition sip_protos.h:11079

## SIPTAG_WARNING

#define SIPTAG_WARNING | ( |  | x | ) |

Tag list item for pointer to a Warning header structure sip_warning_t.

The SIPTAG_WARNING() macro is used to include a tag item with a pointer to a sip_warning_t structure in a tag list.

Parameters

  x | pointer to a sip_warning_t structure, or NULL.

The corresponding tag taking reference parameter is SIPTAG_WARNING_REF().

## SIPTAG_WARNING_STR

#define SIPTAG_WARNING_STR | ( |  | s | ) |

Tag list item for string with Warning header value.

The SIPTAG_WARNING_STR() macro is used to include a tag item with a string containing value of a sip_warning_t header in a tag list.

Parameters

  s | pointer to a string containing Warning header value, or NULL.

The string in SIPTAG_WARNING_STR() can be converted to a sip_warning_t header structure by giving the string s has second argument to function sip_warning_make().

The corresponding tag taking reference parameter is SIPTAG_WARNING_STR_REF().

## Typedef Documentation

## sip_warning_t

typedef msg_warning_t sip_warning_t

@

The Warning response-header field is used to carry additional information about the status of a response. Its syntax is defined in RFC 3261 as follows:

Warning = "Warning" HCOLON warning-value *(COMMA warning-value)
warning-value = warn-code SP warn-agent SP warn-text
warn-code = 3DIGIT
warn-agent = hostport / pseudonym
; the name or pseudonym of the server adding
; the Warning header, for use in debugging
warn-text = quoted-string
pseudonym = token
DIGIT
#define DIGIT
SP
#define SP

The parsed Warning header is stored in sip_warning_t structure.

The structure sip_warning_t contains representation of an Warning header.

The sip_warning_t is defined as follows:

typedef struct msg_warning_s
{
msg_common_t w_common[1]; // Common fragment info
msg_warning_t *w_next; // Link to next @Warning header
unsigned w_code; // Warning code
char const *w_host; // Hostname or pseudonym
char const *w_port; // Port number
char const *w_text; // Warning text
} sip_warning_t;
msg_warning_t
struct msg_warning_s msg_warning_t
msg_common_t
struct msg_common_s msg_common_t
msg_warning_s
msg_warning_s::w_common
msg_common_t w_common[1]
msg_warning_s::w_text
char const * w_text
msg_warning_s::w_port
char const * w_port
msg_warning_s::w_host
char const * w_host
msg_warning_s::w_code
unsigned w_code
msg_warning_s::w_next
msg_warning_t * w_next

## Function Documentation

## sip_is_warning()

int sip_is_warning | ( | sip_header_t const * | header | ) |

inline

Test if header object is instance of sip_warning_t.

Check if the header class is an instance of Warning header object and return true (nonzero), otherwise return false (zero).

Parameters

  header | pointer to the header structure to be tested

Return values

  1 | (true) if the header is an instance of header warning
  0 | (false) otherwise

## sip_warning_copy()

sip_warning_t * sip_warning_copy | ( | su_home_t * | home,
|  | sip_warning_t const * | hdr )

inline

Copy a list of Warning header header structures sip_warning_t.

The function sip_warning_copy() copies a header structure hdr. If the header structure hdr contains a reference (`hdr->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the list of header structure hdr.

Parameters

  home | memory home used to allocate new structure
  hdr | pointer to the header structure to be copied

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old hdr header, including the encoding of the old header, if present.

Example
  warning = sip_warning_copy(home, sip->sip_warning);
  sip_warning_copy
  sip_warning_t * sip_warning_copy(su_home_t *home, sip_warning_t const *hdr))
  Copy a list of Warning header header structures sip_warning_t.
  Definition sip_protos.h:11226

Returns
  A pointer to newly copied header structure, or NULL upon an error.

## sip_warning_dup()

sip_warning_t * sip_warning_dup | ( | su_home_t * | home,
|  | sip_warning_t const * | hdr )

inline

Duplicate a list of Warning header header structures sip_warning_t.

Duplicate a header structure hdr. If the header structure hdr contains a reference (`hdr->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  hdr | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  warning = sip_warning_dup(home, sip->sip_warning);
  sip_warning_dup
  sip_warning_t * sip_warning_dup(su_home_t *home, sip_warning_t const *hdr))
  Duplicate a list of Warning header header structures sip_warning_t.
  Definition sip_protos.h:11183

Returns
  A pointer to the newly duplicated sip_warning_t header structure, or NULL upon an error.

## sip_warning_format()

sip_warning_t * sip_warning_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a Warning header from formatting result.

Make a new sip_warning_t object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and parses the formatting result to the structure sip_warning_t.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Returns
  A pointer to newly makes header structure, or NULL upon an error.

## sip_warning_init()

sip_warning_t * sip_warning_init | ( | sip_warning_t | x[1] | ) |

inline

Initialize a structure sip_warning_t.

An sip_warning_t structure for Warning header can be initialized with the sip_warning_init() function/macro. For instance,

sip_warning_t sip_warning;
sip_warning_init(&sip_warning);
sip_warning_init
sip_warning_t * sip_warning_init(sip_warning_t x[1])
Initialize a structure sip_warning_t.
Definition sip_protos.h:11114

## sip_warning_make()

sip_warning_t * sip_warning_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a Warning header structure sip_warning_t.

The function sip_warning_make() makes a new sip_warning_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Returns
  A pointer to newly maked sip_warning_t header structure, or NULL upon an error.

## Variable Documentation

## sip_warning_class

msg_hclass_t sip_warning_class[]

extern

Header class for Warning header.

The header class sip_warning_class defines how a SIP Warning header is parsed and printed. It also contains methods used by SIP parser and other functions to manipulate the sip_warning_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.